﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GanttView;
using Telerik.Windows.Controls.Scheduling;

namespace GanttChooseSummaryContainer
{
    public class ViewModel : ViewModelBase
    {
        private ObservableCollection<CustomGanttTask> tasks;

        private DateRange visibleTime;

        public ViewModel()
        {
            this.tasks = new SoftwarePlanning();
            this.visibleTime = new DateRange(DateTime.Today.AddMonths(-1), DateTime.Today.AddMonths(1));
        }

        public ObservableCollection<CustomGanttTask> Tasks
        {
            get
            {
                return tasks;
            }
            set
            {
                tasks = value;
                OnPropertyChanged(() => Tasks);
            }
        }

        public DateRange VisibleTime
        {
            get
            {
                return this.visibleTime;
            }

            set
            {
                if (this.visibleTime != value)
                {
                    this.visibleTime = value;
                    this.OnPropertyChanged(() => this.VisibleTime);
                }
            }
        }
    }
}
